﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace INT_PT002.DataStore
{
    public class SystemConfiguration
    {
        #region Field
        private int m_RECIPE_NUMBER;

        private int m_CHART1_DRAW_STEP;
        private int m_CHART2_DRAW_STEP;

        private int m_LCD_DATA_PERIOD;
        private int m_CHATTERING;
        private int m_JUDGMENT_DELAY_MSEC;
        private int m_BUZZER_OP;

        private int m_SB_DIFF_FILTER;
        private int m_SB_DIFF_MODE;
        private int m_SB_DATA_MODE;
        private int m_SB_DATA_PERIOD;
        #endregion

        #region Constructor
        public SystemConfiguration()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public int RECIPE_NUMBER
        {
            get { return this.m_RECIPE_NUMBER; }
            set { this.m_RECIPE_NUMBER = value; }
        }

        public int CHART1_DRAW_STEP
        {
            get { return this.m_CHART1_DRAW_STEP; }
            set { this.m_CHART1_DRAW_STEP = value; }
        }
        public int CHART2_DRAW_STEP
        {
            get { return this.m_CHART2_DRAW_STEP; }
            set { this.m_CHART2_DRAW_STEP = value; }
        }

        public int LCD_DATA_PERIOD
        {
            get { return this.m_LCD_DATA_PERIOD; }
            set { this.m_LCD_DATA_PERIOD = value; }
        }
        public int CHATTERING
        {
            get { return this.m_CHATTERING; }
            set { this.m_CHATTERING = value; }
        }
        public int JUDGMENT_DELAY_MSEC
        {
            get { return this.m_JUDGMENT_DELAY_MSEC; }
            set { this.m_JUDGMENT_DELAY_MSEC = value; }
        }
        public int BUZZER_OP
        {
            get { return this.m_BUZZER_OP; }
            set { this.m_BUZZER_OP = value; }
        }

        public int SB_DIFF_FILTER
        {
            get { return this.m_SB_DIFF_FILTER; }
            set { this.m_SB_DIFF_FILTER = value; }
        }
        public int SB_DIFF_MODE
        {
            get { return this.m_SB_DIFF_MODE; }
            set { this.m_SB_DIFF_MODE = value; }
        }
        public int SB_DATA_MODE
        {
            get { return this.m_SB_DATA_MODE; }
            set { this.m_SB_DATA_MODE = value; }
        }
        public int SB_DATA_PERIOD
        {
            get { return this.m_SB_DATA_PERIOD; }
            set { this.m_SB_DATA_PERIOD = value; }
        }
        #endregion

        #region Method
        public void Initialize()
        {
            this.RECIPE_NUMBER = 1;

            this.CHART1_DRAW_STEP = 4;
            this.CHART2_DRAW_STEP = 2;

            this.LCD_DATA_PERIOD = 100;
            this.CHATTERING = 500;
            this.JUDGMENT_DELAY_MSEC = 2000;
            this.BUZZER_OP = 1000;

            this.SB_DIFF_FILTER = 15;
            this.SB_DIFF_MODE = 1;
            this.SB_DATA_MODE = 2;
            this.SB_DATA_PERIOD = 100;
        }
        #endregion
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct StructSystemConfigurationItem
    {
        public int RECIPE_NUMBER;

        public int CHART1_DRAW_STEP;
        public int CHART2_DRAW_STEP;

        public int LCD_DATA_PERIOD;
        public int CHATTERING;
        public int JUDGMENT_DELAY_MSEC;
        public int BUZZER_OP;

        public int SB_DIFF_FILTER;
        public int SB_DIFF_MODE;
        public int SB_DATA_MODE;
        public int SB_DATA_PERIOD;
    }
}
