﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SmartX;
using INT_PT002.DataStore;
using INT_PT002.Controls;

namespace INT_PT002.Forms
{
    public partial class FormMainDisplay2 : Form
    {
        #region Field
        private int FlagIgnoreCNT;

        private Color ColorProgressOn;
        private Color ColorProgressOff;
        private Color ColorResultPass;
        private Color ColorResultNG;
        private Color ColorResultNone;

        private FormMain m_ParentForm;

        private ControlMainDisplay ChildControl;
        #endregion

        #region Constructor
        public FormMainDisplay2(FormMain parent)
        {
            InitializeComponent();

            this.ParentForm = parent;

            this.DefaultSetting();
            this.InitializeData();
        } 
        #endregion

        #region Property
        public FormMain ParentForm
        {
            get { return this.m_ParentForm; }
            private set { this.m_ParentForm = value; }
        }
        #endregion

        #region Method
        private void DefaultSetting()
        {
            this.FlagIgnoreCNT = 0;

            this.ColorProgressOff = Color.Azure;
            this.ColorProgressOn = Color.Lime;
            this.ColorResultPass = Color.Green;
            this.ColorResultNG = Color.Red;
            this.ColorResultNone = Color.Black;

            this.ChildControl = new ControlMainDisplay(this.ParentForm);
            this.Controls.Add(this.ChildControl);
            this.ChildControl.Location = new Point(0, 118);
            this.ChildControl.BringToFront();
            this.ChildControl.Visible = false;
        }
        private void InitializeData()
        {

        }

        private void GetJudgmentResult(Define.E_JudgmentStatus judg, SmartLabel label2)
        {
            string value = "";

            switch (judg)
            {
                case Define.E_JudgmentStatus.None:
                    value = "-";
                    label2.TextColor = this.ColorResultNone;
                    label2.Font = new Font("New Gulim", 40, FontStyle.Bold);
                    break;
                case Define.E_JudgmentStatus.Pass:
                    value = "정상";
                    label2.TextColor = this.ColorResultPass;
                    label2.Font = new Font("New Gulim", 40, FontStyle.Bold);
                    break;
                case Define.E_JudgmentStatus.Ng:
                    value = "리크";
                    label2.TextColor = this.ColorResultNG;
                    label2.Font = new Font("New Gulim", 40, FontStyle.Bold);
                    break;
                case Define.E_JudgmentStatus.Error:
                    value = "제품 없음";
                    label2.TextColor = this.ColorResultNone;
                    label2.Font = new Font("New Gulim", 20, FontStyle.Bold);
                    break;
                default:
                    break;
            }

            if (label2.Text != value)
                label2.Text = value;
        }

        public void UpdateProcessStatusDisplay(Define.E_ProcessStatus status)
        {
            switch (status)
            {
                case Define.E_ProcessStatus._0_None:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._1_Initial:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._2_ProductEntry:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;

                    // Label Initialize
                    //this.InitializeLabel();
                    break;
                case Define.E_ProcessStatus._3_ChamberConbined:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._4_VacuumStart:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._5_VacuumHold:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._6_Judgment:
                    break;
                case Define.E_ProcessStatus._7_VacuumBreak:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._8_ChamberSeparation:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOn;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOff;
                    break;
                case Define.E_ProcessStatus._9_ProductRelease:
                    this.labelProgress0.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress1.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress2.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress3.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress4.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress6.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress7.BackGroundColor = this.ColorProgressOff;
                    this.labelProgress8.BackGroundColor = this.ColorProgressOn;
                    break;
                default:
                    break;
            }
        }
        private void UpdateDisplayDotGraphDiff(SmartDraw draw, DiffData diff)
        {
            int iValue = 0;
            double dValue = 0.0;

            // 값 표시 범위
            // 15.000 ~ -2.000  (17.000 ~ 0)
            // 그래프 영역 높이 102
            // 17000 / 102 = 166.666666~
            //dValue = (int.Parse(data.CurrentValueSign + data.CurrentValue) + 2000) / 166.66666;

            if (dValue > 110)
                dValue = 110;
            if (dValue < 1)
                dValue = 1;

            iValue = int.Parse(string.Format("{0:f0}", dValue));
            
            draw.Chart.PutData(iValue);
        }
        private void UpdateDisplayDotGraphDisp(SmartDraw draw, DispData disp)
        {
            int iValue = 0;
            double dValue = 0.0;

            // 값 표시 범위
            // 15.000 ~ -2.000  (17.000 ~ 0)
            // 그래프 영역 높이 102
            // 17000 / 102 = 166.666666~
            //dValue = (int.Parse(data.CurrentValueSign + data.CurrentValue) + 2000) / 166.66666;

            if (dValue > 110)
                dValue = 110;
            if (dValue < 1)
                dValue = 1;

            iValue = int.Parse(string.Format("{0:f0}", dValue));

            draw.Chart.PutData(iValue);
        }
        public void UpdateEquipmentStatusDisplay(Define.E_EquipmentStatus status)
        {
            if (status == Define.E_EquipmentStatus.Start)
            {
                #region Start
                this.labelStart.Visible = true;
                this.labelStop.Visible = false;
                #endregion
            }
            else
            {
                #region Stop
                this.labelStart.Visible = false;
                this.labelStop.Visible = true;
                #endregion
            }
        }

        public void UpdateDisplayDiffData(Collection<DiffData> datas)
        {
         
        }
        public void UpdateDisplayDispData(Collection<DispData> datas)
        {
           
        }

        public void UpdateDisplayJudgmentData(LeakData datas)
        {
            this.timerOn.Enabled = false;
            this.timerOff.Enabled = false;


            this.UpdateDisplayJudgmentData1(datas);
            this.UpdateDisplayJudgmentData2(datas);
            this.UpdateDisplayJudgmentData3(datas);
            this.UpdateDisplayJudgmentData4(datas);
            this.UpdateDisplayJudgmentData5(datas);
            this.UpdateDisplayJudgmentData6(datas);
            this.UpdateDisplayJudgmentData7(datas);
            this.UpdateDisplayJudgmentData8(datas);
            this.UpdateDisplayJudgmentData9(datas);
            this.UpdateDisplayJudgmentData10(datas);

            this.ChildControl.UpdateStartLeakDataDisplay(datas);
        }
        private void UpdateDisplayJudgmentData1(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[0], this.labelResult1);
        }
        private void UpdateDisplayJudgmentData2(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[1], this.labelResult2);
        }
        private void UpdateDisplayJudgmentData3(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[2], this.labelResult3);
        }
        private void UpdateDisplayJudgmentData4(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[3], this.labelResult4);
        }
        private void UpdateDisplayJudgmentData5(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[4], this.labelResult5);
        }
        private void UpdateDisplayJudgmentData6(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[5], this.labelResult6);
        }
        private void UpdateDisplayJudgmentData7(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[6], this.labelResult7);
        }
        private void UpdateDisplayJudgmentData8(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[7], this.labelResult8);
        }
        private void UpdateDisplayJudgmentData9(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[8], this.labelResult9);
        }
        private void UpdateDisplayJudgmentData10(LeakData data)
        {
            //this.GetJudgmentResult(data.CollJudgment[9], this.labelResult10);
        }
        public void UpdateDisplayTime()
        {
            this.labelTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        }

        public void DisplayRefresh()
        { 
            
        }
        #endregion

        #region Event Handler
        private void labelStop_Click(object sender, EventArgs e)
        {
            this.ParentForm.TransferData(CommunicationCommand.Start, CommunicationID.MainBoard);
        }
        private void labelStart_Click(object sender, EventArgs e)
        {
            this.ParentForm.TransferData(CommunicationCommand.Stop, CommunicationID.MainBoard);
        }
        private void buttonMenu_Click(object sender, EventArgs e)
        {
            this.ParentForm.ChildFormMenu.DisplayRefresh();
            this.ParentForm.FormChange((int)Define.E_FormStore.FormMenu);
        }
        private void buttonDisplayGraph_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(1);
            this.ChildControl.Visible = true;
        }
        private void buttonCut_Click(object sender, EventArgs e)
        {
            this.ParentForm.TransferData(CommunicationCommand.CutInpupt, CommunicationID.MainBoard);

            this.InitializeData();
            this.ChildControl.ClearAllData();

            for (int i = 0; i < 10; i++)
            {
                //this.CollectionResult[i].Font = new Font("New Gulim", 20, FontStyle.Bold);
                //this.CollectionResult[i].Text = "검사 중..";
            }

            this.timerOn.Enabled = true;
        }

        private void smartDraw1_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(1);
            this.ChildControl.Visible = true;
        }
        private void smartDraw2_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(2);
            this.ChildControl.Visible = true;
        }
        private void smartDraw3_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(3);
            this.ChildControl.Visible = true;
        }
        private void smartDraw4_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(4);
            this.ChildControl.Visible = true;
        }
        private void smartDraw5_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(5);
            this.ChildControl.Visible = true;
        }
        private void smartDraw6_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(6);
            this.ChildControl.Visible = true;
        }
        private void smartDraw7_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(7);
            this.ChildControl.Visible = true;
        }
        private void smartDraw8_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(8);
            this.ChildControl.Visible = true;
        }
        private void smartDraw9_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(9);
            this.ChildControl.Visible = true;
        }
        private void smartDraw10_Click(object sender, EventArgs e)
        {
            this.ChildControl.DisplayRefresh(10);
            this.ChildControl.Visible = true;
        }
        private void buttonClear_Click(object sender, EventArgs e)
        {
            this.InitializeData();
            this.ChildControl.ClearAllData();
        }

        private void timerOn_Tick(object sender, EventArgs e)
        {
            this.timerOn.Enabled = false;

            //for (int i = 0; i < 10; i++)
            //    this.CollectionResult[i].Visible = false;

            this.timerOff.Enabled = true;
        }
        private void timerOff_Tick(object sender, EventArgs e)
        {
            this.timerOff.Enabled = false;

            //for (int i = 0; i < 10; i++)
            //    this.CollectionResult[i].Visible = true;

            this.timerOn.Enabled = true;
        }
        #endregion

        private void buttonExit_Click(object sender, EventArgs e)
        {
            this.ParentForm.CloseSmartUartLink();
            this.ParentForm.Dispose();
            this.ParentForm.Close();
        }
    }
}